proc Netspace {name args} {global currentNet
switch {} $currentNet {} default {if [notDefaultNet] {error "Nested Netspace directive for $name."}}
nsLoad $name 0 $args}
proc nsLoad {name show opts} {global XTO currentNet DEBUG zircon
set f [file join $zircon(prefdir) netspaces $name]
if ![file exists $f] {tellError {} Netspace "Cannot find Netspace $name"
return 0}
if [file isdirectory $f] {set f [file join $f preferences]
if ![file exists $f] {tellError {} Netspace "Cannot find Netspace preferences for $name"
return 0}}
set ln [string tolower $name]
if [info exists XTO($ln)] {for {set i 1} {[info exists XTO($ln$i)]} {incr i} {}
set nn1 $name$i
if ![askUser {} {Netspace Load} "Netspace \"$name\" is already loaded. It will be loaded under the name \"$nn1\"."] return
addToNM $nn1} {set nn1 $name}
set sc $currentNet
set currentNet [Net $nn1]
makeDefaults $currentNet
if [catch {source $f} msg] {tellError {} {Netspace error} "Error in netspace $nn1 - $msg"} {InitNet $currentNet
$currentNet show
if $show {exposeFrame .@ctl $currentNet
exposeFrame .@inf $currentNet}
if $DEBUG {zDBGAdd $currentNet}}
set currentNet $sc}
proc nsUnload name {global zircon
foreach x [Net :: list] {switch -- $name [$x name] {if ![file exists [file join $zircon(prefdir) netspaces $name]] {delFromNM [$x name]}
$x delete
break}}}
proc notDefaultNet {} {global currentNet defaultNet
switch $currentNet $defaultNet {return 0}
return 1}
proc isNotDefaultNet net {global defaultNet
switch $net $defaultNet {return 0}
return 1}
