proc makeArray args {foreach x $args {global $x
set ${x}(1) 1
unset ${x}(1)}}
proc window chan {return [[find $chan] window]}
proc normal w {switch normal [$w cget -state] {return 1}
return 0}
proc capitalise str {return [string toupper [string index $str 0]][string range $str 1 end]}
proc getOption {var dflt} {global $var
switch {} [set $var [option get . $var [capitalise $var]]] {set $var $dflt}}
proc listmember {list val} {return [expr {[lsearch $list $val] >= 0}]}
proc listkill {list val} {upvar $list lst
if {[set x [lsearch $lst $val]] >= 0} {set lst [lreplace $lst $x $x]}}
proc listincl {list val} {upvar $list lst
if ![listmember $lst $val] {lappend lst $val}}
proc listmatch {list val} {set i 0
foreach item $list {switch -- [lindex $item 0] $val {return $i}
incr i}
return -1}
proc listdel {v item} {upvar $v lst
catch {set lst [lreplace $lst $item $item]}}
proc listupdate {list item val} {upvar $list lst
while {[llength $lst] <= $item} {lappend lst {}}
set lst [lreplace $lst $item $item $val]}
proc listmove {list from to val} {upvar $list lst
set lst [linsert [lreplace $lst $from $from] $to $val]}
proc prune {name lng} {regsub -all "\[\002\017\026\037\]" $name {} name
return [expr {[string length $name] > $lng ?  "[string range $name 0 [expr {$lng - 3}]]..." : $name}]}
proc killWindow win {global Icon IconBM
catch {unset Icon($win)}
catch {unset IconBM($win)}
catch {destroy $win}}
proc me {nk net} {switch -- [string tolower $nk] [[$net myid] lname] {return 1}
return 0}
set ctcpCmds {Clientinfo Echo Errmsg Finger Pid Ping Source Time
Version Userinfo Other}
set specialCmds {Zircon}
proc addCTCPMenu {net name usr} {global ctcpCmds DEBUG specialCmds ztrans
$name add cascade -label $ztrans(ctcp) -menu $name.ctcp
menu $name.ctcp
set cmdlst $ctcpCmds
switch {} [$net wavplayer] {} default {lappend cmdlst Sound}
if $DEBUG {lappend cmdlst Zircon}
foreach cmd $cmdlst {switch {{}} $usr {set prc "usersCTCP $net [string toupper $cmd]"
$name.ctcp configure -tearoff 0} default {set prc "doCtcp $net [string toupper $cmd] \[$usr name\]"
catch {$name.ctcp configure -tearoffcommand "retitle \"CTCP menu for \[$usr name\]\""}}
$name.ctcp add command -label [trans $cmd] -command $prc}}
proc addChanCTCPMenu {name ctl} {global ctcpCmds DEBUG specialCmds ztrans
$name add cascade -label $ztrans(ctcp) -menu $name.ctcp
menu $name.ctcp -tearoff 0
foreach cmd [expr {$DEBUG ? [concat $ctcpCmds $specialCmds] : $ctcpCmds}] {$name.ctcp add command -label [trans $cmd] -command "chanCTCP [string toupper $cmd] $ctl"}}
proc addDCCMenu {name usr} {global ztrans
$name add cascade -label $ztrans(dcc) -menu $name.dcc
menu $name.dcc -tearoff 0
foreach cmd {Send Chat} {$name.dcc add command -label [trans $cmd] -command "doDCC [$usr net] [string toupper $cmd] \[$usr name\]"}}
proc makeUserMenu {chid win usr} {if [winfo exists $win] {return $win}
return [menu $win -postcommand "postUM $chid $win $usr"]}
proc postUM {chid win usr} {global ztrans ucmds Ops
set w [winfo parent $win]
set net [$usr net]
set nrm [string compare nil $chid]
array set ucmds "
	Whois	{$net WHOIS \[$usr lname\]}
	Message	{Message :: make \[$usr name\] $net}
	Notice	{channelNotice $net \[$usr lname\]}
	Time	{$net TIME \[$usr name\]}
	CTCP	{}
	DCC	{}
	Notify	{}
	Ignore	{}
	Finger	{}
	Speak	{}
	ChanOp	{}
	Kick	{$chid kick $usr}
	Ban	{doBan $net + $chid \[$usr name\]!*@*}
	BanKick {$chid banKick $usr}
	Kill	{}
    "
foreach cmd $Ops(userMenu) {switch $cmd {CTCP {addCTCPMenu $net $win $usr} DCC {addDCCMenu $win $usr} Notify {$win add checkbutton -label $ztrans(notify) -variable ${usr}(notify) -command "$usr doNotify"} Whois - Message - Notice - Time {$win add command -label [trans $cmd] -command $ucmds($cmd)} Ignore {if $nrm {addIgnoreMenu $win $usr}} Finger {if $nrm {$win add command -label $ztrans(finger) -command "$usr finger"}} Silence {if [$net undernet] {$win add cascade -label $ztrans(silence) -menu $win.silence
menu $win.silence -tearoff 0
$win.silence add command -label $ztrans(silence) -command "underUSilence + $net $usr"
$win.silence add command -label $ztrans(delete) -command "underUSilence - $net $usr"}}}}
if $nrm {set st [expr {(![$net restricted] && [$chid operator]) ? "normal" : "disabled"}]
foreach cmd $Ops(chanop) {switch $cmd {Speak {$win add checkbutton -label $ztrans(speak) -variable ${chid}(Spk,$usr) -command "$chid userMode $usr v" -state $st} ChanOp {$win add checkbutton -label $ztrans(chanop) -variable ${chid}(Op,$usr) -command "$chid userMode $usr o" -state $st} Kick - Ban - BanKick {$win add command -label [trans $cmd] -command $ucmds($cmd) -state $st}}}
foreach cmd $Ops(ircop) {switch $cmd {Kill {$win add command -label $ztrans(kill) -command "$usr kill" -state [expr {[$net ircop] ? {normal} : {disabled}}] -foreground red}}}}
$win configure -postcommand {}}
proc invert button {set fg [$button cget -foreground]
set bg [$button cget -background]
set afg [$button cget -activeforeground]
set abg [$button cget -activebackground]
$button conf -foreground $bg -background $fg -activeforeground $abg -activebackground $afg}
proc makeLB {win args} {frame $win -borderwidth 0
grid columnconfigure $win 0 -weight 1
grid rowconfigure $win 0 -weight 1
scrollbar $win.vs -command "$win.l yview"
scrollbar $win.hs -command "$win.l xview" -orient horizontal
eval listbox $win.l -xscrollcommand "{ghsSet $win.hs}" -yscrollcommand "{gvsSet $win.vs}" -selectmode single $args
grid $win.l -row 0 -column 0 -sticky nsew
return $win}
proc ghsSet {sb f l} {switch 0 $f {switch 1 $l {catch {grid forget $sb
return}}}
catch {grid $sb -row 1 -column 0 -sticky ew}
$sb set $f $l}
proc gvsSet {sb f l} {switch 0 $f {switch 1 $l {catch {grid forget $sb
return}}}
catch {grid $sb -row 0 -column 1 -sticky ns}
$sb set $f $l}
proc utest {net win x y cmd} {set name [lindex [$win tag names @$x,$y] 0]
switch -glob -- $name {user* {eval $cmd \{[$name lname]\} $net} @?@user* {eval $cmd \{[[string range $name 3 end] lname]\} $net}}
notIdle $win}
proc who2 {net name} {$net WHOIS $name $name}
proc rebind {txt net} {$txt configure -state disabled -takefocus 0
bind $txt <Any-KeyPress> {notIdle %W ; break}
bind $txt <Double-Button-2> "utest $net %W %x %y {Message :: make}"
bind $txt <Shift-Double-Button-2> "utest $net %W %x %y who2"
bind $txt <Control-Double-Button-2> "utest $net %W %x %y finger"
bind $txt <Double-3> "findURL %W %x %y $net"}
proc retitle {t w1 w2} {wm title $w2 $t}
proc switchFrame {ctl net title args} {global zDIOff
set rq [llength [grid slaves $ctl -column 0]]
grid rowconfigure $ctl $rq -weight 1 -minsize 30
grid [set mn [frame $ctl.$net -borderwidth 0]] -sticky nsew -row $rq -column 0
grid columnconfigure $mn 0 -weight 1
grid rowconfigure $mn 2 -weight 1
addSeparator $mn -row 0 -column 0
grid [set f [frame $mn.exp -borderwidth 0]] -sticky ew -row 1 -column 0
grid columnconfigure $f 1 -weight 1
grid [button $f.ctl -image $zDIOff -command "exposeFrame $ctl $net"] -row 0 -column 0
grid [label $f.title -text $title] -row 0 -column 1 -sticky ew
return [frame $mn.bdy -borderwidth 0]}
proc checkHeight w {update idletasks
set ht [winfo reqheight $w]
if {$ht != [winfo height $w]} {wm geometry $w [winfo width $w]x$ht}}
proc exposeFrame {ctl net} {global zDIOff zDIOn zDIOff1 zDIOn1
set w $ctl.$net.exp
set forget 1
switch [$w.ctl cget -image] $zDIOff {set im $zDIOn
set forget 0} $zDIOff1 {set im $zDIOn1
set forget 0} $zDIOn {set im $zDIOff} $zDIOn1 {set im $zDIOff1}
$w.ctl configure -image $im
if $forget {grid forget $ctl.$net.bdy} {grid $ctl.$net.bdy -sticky nsew -row 2 -column 0}}
proc retitleFrame {ctl net title args} {global zDIOff1 zDIOff zDIOn zDIOn1
append ctl .$net.exp
set im [$ctl.ctl cget -image]
set fg black
switch {} $args {} default {switch [$ctl.ctl cget -image] $zDIOff {set im $zDIOff1
set fg red} $zDIOff1 {set im $zDIOff
set fg black} $zDIOn {set im $zDIOn1
set fg red} $zDIOn1 {set im $zDIOn
set fg black}}
$ctl.ctl configure -image $im
$ctl.title configure -text $title -fg $fg}
proc hideFrame {ctl net} {foreach x [winfo children $ctl.$net] {switch -glob $x *.bdy {} default {grid forget $x}}}
proc deleteFrame {ctl net} {destroy $ctl.$net}
proc makeMB {win text} {menubutton $win -text [trans $text] -menu $win.menu
return [menu $win.menu]}
proc addSeparator {w args} {global zircon
eval grid [frame $w.[newName s] -background $zircon(sepColor) -borderwidth 4] -sticky ew -pady 4 $args}
