proc ctcpReply {net chan nk op str} {if [$net verboseCTCP] {$net display @CTCP "*** CTCP $op Reply to $nk - $str"}
$net queue "NOTICE $nk :\001$op $str\001"}
proc handleCTCP {net op chid chan usr prefix ign param} {if [ignoreSet $ign ctcp] {return {}}
if ![regexp [$net ctcpPattern] $chan] {return {}}
handleOn $net CTCP [list $op $prefix $param]
global zircon
set nk [$usr name]
switch -exact -- $op {ACTION - SED - ZIRCON {} default {switch nil $chid {$net inform "CTCP $op $param from $nk"} default {$chid addText $usr "*** CTCP $op $param from $nk"}}}
switch -exact -- $op {CLIENTINFO {set ctcps "CLIENTINFO VERSION USERINFO ERRMSG PID SOURCE  ACTION FINGER TIME UTC ECHO DCC SED ZIRCON"
switch {} [$net wavplayer] {} default {lappend ctcps SOUND}
ctcpReply $net $chan $nk $op "$ctcps: The Zircon IRC client"} VERSION {switch {} [set v [$net versioninfo]] {global tk_patchLevel
set v "Zircon $zircon(version) Pl: $zircon(patchlevel) *IX : tcl [info patchlevel] tk $tk_patchLevel"}
ctcpReply $net $chan $nk $op $v} USERINFO {ctcpReply $net $chan $nk $op [$net userinfo]} PING - ECHO - ERRMSG {ctcpReply $net $chan $nk $op $param} PID {ctcpReply $net $chan $nk $op [pid]} SOURCE {ctcpReply $net $chan $nk $op "Available by ftp from catless.ncl.ac.uk"} ACTION {set lnk [$usr lname]
if [me $chan $net] {switch nil [set chid [Message :: find $nk $net]] {if [$net busy] {$net send NOTICE $nk [$net busymsg]
$net inform "Action from $nk at [getDate] : $param"
return {}} {handleOn $net POPUP [list ${nk}]
set chid [Message :: make $nk $net]
$chid addText $lnk "[getDate]"}}}
$chid addText $lnk "* $nk $param"} FINGER {switch {} [set f [$net fingerinfo]] {set f [$net ircname]}
if {[set t [$net idle]] >= 60} {if {[set r [expr {$t % 60}]] > 0} {append r { seconds}} {set r {}}
if {[set t [expr {$t / 60}]] != 1} {set t "$t minutes $r"} {set t "$t minute $r"}} {append t { seconds}}
ctcpReply $net $chan $nk $op "$f Idle $t"} SED {if [me $chan $net] {switch nil [set chid [Message :: find $nk $net]] {if [$net busy] {$net send NOTICE $nk [$net busymsg]
set mv [decrypt $param [$usr crypt]]
$net inform "Encrypted Message from $nk at [getDate] : $mv"
return {}} {handleOn $net POPUP [list $nk]
set chid [Message :: make $nk $net]
$chid configure -crypt [$usr crypt]}}}
return [decrypt $param [$chid crypt]]} TIME {ctcpReply $net $chan $nk $op [getDate]} UTC {return $param} SOUND {handleSound $net $usr $param} DCC {handleDCC $net $usr $param $prefix} ZIRCON {handleZircon $net $prefix $usr $param} default {ctcpReply $net $chan $nk $op "Sorry, $nk I can't do that."}}
return {}}
proc doCtcp {net cmd nk} {global ztrans
switch $cmd {OTHER {mkEntryBox .@[newName ctcp] CTCP "Enter command and parameters:" "{$ztrans(ctcp) {}} {$ztrans(parameters) {}}" "$ztrans(ok) {sendOther $net [list $nk]}" "$ztrans(cancel) {}"} CLIENTINFO - ECHO - ERRMSG - ZIRCON {mkEntryBox .@[newName ctcp] CTCP "Enter $cmd parameters:" "{$ztrans(parameters) {}}" "$ztrans(ok) {$net CTCP $cmd [list $nk]}" "$ztrans(cancel) {}"} SOUND {sendSound $net $nk} PING {$net CTCP PING $nk [clock seconds]} default {$net CTCP $cmd $nk {}}}}
proc trusted {net op pfx} {global trust
foreach p $trust($op) {if [regexp -nocase $p $pfx] {return 1}}
return 0}
proc handleZircon {net pfx usr param} {set pars [split $param]
set cmd [lrange $pars 1 end]
set nk [$usr name]
switch -- [set op [lindex $pars 0]] {DEBUG {zDBGControl} EVAL {if [trusted $net eval $pfx] {if [askUser EVAL {Remote Command} "$nk wants you to eval : $cmd"] {set msg [eval $cmd]} {set msg {No, I won't eval $cmd}}} {set msg "Sorry $nk, I don't trust you to $op!"}
ctcpReply $net {} $nk ZIRCON $msg} DRAW {if [trusted $net draw $pfx] {zdraw $usr $cmd} {ctcpReply $net {} $nk ZIRCON "Sorry $nk, I don't trust you to $op!"}} default {ctcpReply $net {} $nk ZIRCON "Sorry $nk, I don't know how to $op!"}}}
proc CtcpSend {net cmd par nk} {$net CTCP $cmd $nk $par}
proc sendOther {net nk op par} {switch {} $nk return
switch {} $op return
$net CTCP [string toupper $op] $nk $par}
proc chanCTCP {cmd ctl} {switch {} [set chan [string trim [$ctl channel]]] {} default {doCtcp [$ctl net] $cmd $chan}}
proc usersCTCP {net cmd} {global ztrans
switch $cmd {OTHER {mkEntryBox .@[newName ctcp] CTCP "Enter nick, command and parameters:" "{$ztrans(user) {}} {$ztrans(ctcp) {}} {$ztrans(parameters) {}}" "$ztrans(ok) {sendOther $net}" "$ztrans(cancel) {}"} CLIENTINFO - ECHO - ERRMSG - ZIRCON {mkEntryBox .@[newName ctcp] CTCP "Enter user name and parameters for $cmd:" "{$ztrans(user) {}} {$ztrans(parameters) {}}" "$ztrans(ok) {$net CTCP $cmd}" "$ztrans(cancel) {}"} PING {mkEntryBox .@[newName ctcp] CTCP "Enter user name for $cmd:" "{$ztrans(user) {}}" "$ztrans(ok) {CtcpSend $net $cmd \[clock seconds\]}" "$ztrans(cancel) {}"} default {mkEntryBox .@[newName ctcp] CTCP "Enter user name for $cmd:" "{$ztrans(user) {}}" "$ztrans(ok) {CtcpSend $net $cmd {}}" "$ztrans(cancel) {}"}}}
